function results = DHToCoords(params, coords)
% builds chains for parameters 

torad = pi/180;
[ii,jj,kk,ll] = size(params);

results = coords(:,:,ones(kk,1), ones(ll,1)); % start by copying coords, because first two shouldn't move. 

startFrame = makeFrame(coords(1:3,:));

for l = 1:ll
    for k = 1:kk
        frame = startFrame;
        for i = 1:size(params,1)
            % frame = frame*DH(params(i,:,k,l)); % inline DH for speed
            p = params(i,:,k,l);
            if length(p) < 4
                a = 0;
            else
                a = p(4);
            end
            C = cos(p(1)*torad);
            S = sin(p(1)*torad);
            L = cos(p(2)*torad);
            M = sin(p(2)*torad);
            
            frame = frame*[C -S*L   S*M  a*C; % apply DH
                           S  C*L  -C*M  a*S;
                           0   M     L   p(3);
                           0   0     0   1];
            results(i+2,:,k,l) = frame(1:3,4)'; % save point
        end
    end
end
