function [coordMatrix, atomList] = getSideCoords(numOper, s, operFcnHdl, bbCoords)
% given a list of backbone coordinates for N, CA, C,
% computes and returns the H, Cb, and O, hanging off them.
% s indicates which atom begins the list (ca=1, c=2, n=3) and is the index
% into operFcnHdl = [@oper_ca2cb, @oper_c2o, @oper_n2h], which does the
% computation. 
% Returns matrices of coordinates of atoms in two ways, 
% coordMatrix(Type, point, :) has them broken down by Type [ca=1,c,n,cb,o,h=6],  
%  and atomList is just a list of all atoms.
%

three = 1:3;
% operFcnHdl = [@oper_ca2cb, @oper_c2o, @oper_n2h];
lengthofFcnHdl = length(operFcnHdl);
numCycles = floor(numOper/3)+1;
count = zeros(1,3);
atomList = zeros(2*(numOper+1), 3);
coordMatrix = zeros(6,numCycles,3);

index = s;
for i = 1:(numOper+1)
    [outCoords, sideCoords] = feval(operFcnHdl(index), bbCoords(i,:),bbCoords(i+1,:),bbCoords(i+2,:)); 
    count(index) = count(index)+1;
    coordMatrix(index,count(index),:) = outCoords;
    coordMatrix(index+3,count(index),:) = sideCoords;
    atomList(2*(i-1)+1,:) = outCoords;
    atomList(2*(i-1)+2,:) = sideCoords;
    index = index + 1;  % increment index for next atom (position returned by buildchain)
    if index > lengthofFcnHdl % mod index by 3
        index = 1;
    end;
end;

% count(index) = count(index) + 1;
% atomList(end-1,:) = bbCoords(end-1,:);  
% atomList(end,:) = bbCoords(end-1,:);  % side coords for first atom, just need to take up space.
% coordMatrix(index,count(index),:) = bbCoords(end-1,:);
% coordMatrix(index+3,count(index),:) = bbCoords(end-1,:);

% % cbeta
% idealNCaCbAng = 110.4*deg;
% idealCCaCbAng = 110.5*deg;
% idealCaCbLen = 1.521;
% % oxygen
% idealCaCOAng = 120.8*deg;
% idealNCOAng = 123.0*deg;
% idealCOLen = 1.231;
% % Hydrogen
% idealCNHAng = 123.8*deg;
% idealCalphaNHAng = 114.4*deg;
% idealNHLen = 1.00;
