function separate = writeKinD(filenameKin, resName, startAtomNum, numOper, wiggleRes, branchNum, varAngName, coordMatrix, atomList, ndVectors, norms, endDots, deltaDots, color, writeOption, kinNum)
                    
s = startAtomNum;

if (s == 1)
    atomNumN = wiggleRes-1;
    atomNumCA = wiggleRes-1; 
    atomNumC = wiggleRes-1;
    atomNumBB = wiggleRes-1;
elseif ( s == 2)
    atomNumN = wiggleRes;
    atomNumCA = wiggleRes-1;
    atomNumC = wiggleRes-1;
    atomNumBB = wiggleRes-1;
end;

if (s==1)
    atomListNames = [' n  '; ' h  '; ' ca '; ' cb '; ' c  ';' o  '];
elseif (s==2)
    atomListNames = [' ca '; ' cb '; ' c  ';' o  '; ' n  '; ' h  '];
else
    atomListNames = [' c  ';' o  '; ' n  '; ' h  '; ' ca '; ' cb '];
end;

bbPointLine = [' L '; ' L '; ' L '; ' L '; ' L '; ' L '];

numAtomList = size(atomList,1);
numVectors = size(ndVectors,1);
numCycles = ceil(numOper/3);

numN = numCycles;
numH = numCycles;
numCa = numCycles;
numCb = numCycles;
numC = numCycles;
numO = numCycles;

pointN = zeros(numCycles,3);
pointCa = zeros(numCycles,3);
pointC = zeros(numCycles,3);
pointH = zeros(numCycles,3);
pointCb = zeros(numCycles,3);
pointO = zeros(numCycles,3);

for i = 1:numCycles
    pointN(i,:) = coordMatrix(1,i,:);
    pointCa(i,:) = coordMatrix(2,i,:);
    pointC(i,:) = coordMatrix(3,i,:);
    pointH(i,:) = coordMatrix(4,i,:);
    pointCb(i,:) = coordMatrix(5,i,:);
    pointO(i,:) = coordMatrix(6,i,:);
end;

zeroV = [0 0 0];
if isequal(pointN(numCycles,:),zeroV)
    pointN(numCycles,:) = [];
    numN = numCycles-1;
end;
if isequal(pointCa(numCycles,:),zeroV)
    pointCa(numCycles,:) = [];
    numCa = numCycles-1;
end;
if isequal(pointC(numCycles,:),zeroV)
    pointC(numCycles,:) = [];
    numC = numCycles-1;
end;
if isequal(pointH(numCycles,:),zeroV)
    pointH(numCycles,:) = [];
    numH = numCycles-1;
end;
if isequal(pointCb(numCycles,:),zeroV)
    pointCb(numCycles,:) = [];
    numCb = numCycles-1;
end;
if isequal(pointO(numCycles,:),zeroV)
    pointO(numCycles,:) = [];
    numO = numCycles-1;
end;

if (size(resName,2) == 3)
    resName = [' ', resName];
end
    
if (nargin > 14) 
    fid = fopen(filenameKin, writeOption);
else
    fid = fopen(filenameKin, 'w');
    kinNum=1;
end

outstring = sprintf('@kinemage %g', kinNum);
outstring = [outstring, '\n @pdbfile {} \n'];
outstring = [outstring, '@onewidth \n'];
outstring = [outstring, '@zoom 1.00 \n'];
outstring = [outstring, '@zslab 200 \n'];
outstring = [outstring, '@ztran 0 \n'];
outstring = [outstring, '@matrix \n'];
outstring = [outstring, '1.000000 0.000000 0.000000 0.000000 1.000000 0.000000 0.000000 0.000000 1.000000 \n'];
outstring = [outstring, sprintf('@group {branch %d} \n', branchNum)];
% MAINCHAIN
outstring = [outstring, '@subgroup {mainchain} dominant\n'];
outstring = [outstring, '@balllist {N} color = blue master = {mainchain} radius = 0.05 \n'];
fprintf(fid, outstring); 
for i = 1:numN
		outstring =  ['{ n '...
       	    sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumN)...
       	    ' } '...
           	sprintf('%6f,', pointN(i,1))...
       	    sprintf('%6f,', pointN(i,2))...
       	    sprintf('%6f', pointN(i,3)), '\n'];
        fprintf(fid, outstring);        
end
outstring = [outstring, '@balllist {C} color = grey master = {mainchain} radius = 0.05 \n'];
fprintf(fid, outstring);  
for i = 1:numC
		outstring =  ['{ c  '...
       	    sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumC)...
       	    ' } '...
           	sprintf('%6f,', pointC(i,1))...
       	    sprintf('%6f,', pointC(i,2))...
       	    sprintf('%6f', pointC(i,3)), '\n'];
        fprintf(fid, outstring);        
end
outstring = [outstring, '@balllist {CA} color = grey master = {mainchain} radius = 0.05 \n'];
fprintf(fid, outstring); 
for i = 1:numCa
		outstring =  ['{ ca  '...
       	    sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumCA)...
       	    ' } '...
           	sprintf('%6f,', pointCa(i,1))...
       	    sprintf('%6f,', pointCa(i,2))...
       	    sprintf('%6f', pointCa(i,3)), '\n'];
        fprintf(fid, outstring);        
end
outstring = [outstring, '@balllist {O} color = red master = {mainchain} radius = 0.05 \n'];
fprintf(fid, outstring);
for i = 1:numO
		outstring =  ['{ o  '...
       	    sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumC)...
       	    ' } '...
           	sprintf('%6f,', pointO(i,1))...
       	    sprintf('%6f,', pointO(i,2))...
       	    sprintf('%6f', pointO(i,3)), '\n'];
        fprintf(fid, outstring);        
end
outstring = [outstring, '@vectorlist {mc} color = white master = {mainchain} \n'];
fprintf(fid, outstring);
index = 0;
for i = 1:2:numAtomList
    index = index+1;
		outstring = ['{'...
			atomListNames(mod(i-1,6)+1,:)...
			sprintf('%4s', resName)...
			sprintf('%5d', i - 1 + atomNumBB)...
			' }   '...
			bbPointLine(mod(i-1,6)+1,:)...
			sprintf('%6f,', atomList(i,1))...
			sprintf('%6f,', atomList(i,2))...
			sprintf('%6f', atomList(i,3)), '\n'];
   	    fprintf(fid,outstring);
end
outstring = [outstring, '@vectorlist {co} color= white  master= {mainchain} \n'];
fprintf(fid,outstring);
for i = 1:numO
		outstring =  ['{'...
           	' c '...
       	    sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumC)...
           	' }  P '...
            sprintf('%6f,', pointC(i,1))...
       	    sprintf('%6f,', pointC(i,2))...
       	    sprintf('%6f', pointC(i,3)), '\n'...
           	' {  '...
            ' o '...
       	    sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumC)...
       	    ' } L '...
            sprintf('%6f,', pointO(i,1))...
       	    sprintf('%6f,', pointO(i,2))...
       	    sprintf('%6f', pointO(i,3)), '\n'];
   	    fprintf(fid,outstring);
end
% HYDROGENS
outstring = [outstring, '@vectorlist {mc H} color= gray lens master= {mainchain} \n'];
fprintf(fid,outstring);
for i = 1:numH
		outstring =  ['{ n '...
       	    sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumN)...
       	    ' } P '...
           	sprintf('%6f,', pointN(i,1))...
       	    sprintf('%6f,', pointN(i,2))...
       	    sprintf('%6f', pointN(i,3)), '\n'...
			'{ h '...
           	sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumN)...
           	' } L '...
            sprintf('%6f,',pointH(i,1))...
           	sprintf('%6f,', pointH(i,2))...
           	sprintf('%6f', pointH(i,3)), '\n'];
   	    fprintf(fid,outstring);
end

% SIDECHAIN
outstring = [outstring, '@subgroup {sidechain} dominant \n'];
outstring = [outstring, '@balllist {CB} color = cyan master = {mainchain} radius = 0.05 \n'];
fprintf(fid, outstring);
for i = 1:numCb
		outstring =  ['{ cb  '...
   	        sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumCA)...
            ' } '...
           	sprintf('%6f,', pointCb(i,1))...
			sprintf('%6f,', pointCb(i,2))...
			sprintf('%6f', pointCb(i,3)), '\n'];
        fprintf(fid, outstring);        
end
outstring = [outstring, '@vectorlist {sc} color= cyan  master= {mainchain} \n'];
fprintf(fid,outstring);
for i = 1:numCb
		outstring =  ['{ ca '...
   	        sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumCA)...
       	    ' }  P '...
            sprintf('%6f,', pointCa(i,1))...
   	        sprintf('%6f,', pointCa(i,2))...
   	        sprintf('%6f', pointCa(i,3)), '\n'...
       	    ' {  cb '...
   	        sprintf('%4s', resName)...
            sprintf('%5d', i - 1 + atomNumCA)...
   	        ' } L '...
            sprintf('%6f,', pointCb(i,1))...
   	        sprintf('%6f,', pointCb(i,2))...
   	        sprintf('%6f', pointCb(i,3)), '\n'];
   	    fprintf(fid,outstring);
end
numEndDots = size(endDots,1); 
outstring = [outstring, '@balllist {endDots} color = pinktint radius = 0.015 \n'];
fprintf(fid, outstring); 
for i = 1:numEndDots
		outstring =  ['{ ed '...
       	    sprintf('%4s', resName)...
            sprintf('%5d', i - 1 )...
       	    ' } '...
           	sprintf('%6f,', endDots(i,1))...
       	    sprintf('%6f,', endDots(i,2))...
       	    sprintf('%6f', endDots(i,3)), '\n'];
        fprintf(fid, outstring);        
end
numDeltaDots = size(deltaDots,1); 
outstring = [outstring, '@balllist {deltaDots} color = pinktint master = {deltaDots} radius = 0.015 \n'];
fprintf(fid, outstring); 
for i = 1:numDeltaDots
		outstring =  ['{ dd '...
       	    sprintf('%4s', resName)...
            sprintf('%5d', i - 1 )...
       	    ' } '...
           	sprintf('%6f,', deltaDots(i,1))...
       	    sprintf('%6f,', deltaDots(i,2))...
       	    sprintf('%6f', deltaDots(i,3)), '\n'];
        fprintf(fid, outstring);        
end
outstring = [sprintf('@arrowlist {d_%4s} color = %s  master = {d%4s_branch%d} radius = 0.100 angle = 30.000', varAngName,color,varAngName, branchNum), '\n'];
fprintf(fid,outstring);
for i = 1:numVectors
    a = 1;
    if norms(i) < .1
        a = 0;
    end;
    outstring =  ['{'...
        atomListNames(mod(i-1,6)+1,:) ...
        sprintf('%4s', resName)...
        sprintf('%5d', i - 1)...
        ' }  P '...
        sprintf('%6f,', atomList(i,1))...
        sprintf('%6f,', atomList(i,2))...
        sprintf('%6f', atomList(i,3)), '\n'...
        '{'...
        atomListNames(mod(i-1,6)+1,:)...
        sprintf('%4s', resName)...
        sprintf('%5d', i - 1)...
        ' }  A '...
        sprintf('%6f,', atomList(i,1) + ndVectors(i,1))...
        sprintf('%6f,', atomList(i,2) + ndVectors(i,2))...
        sprintf('%6f', atomList(i,3) + ndVectors(i,3)), '\n'];
        fprintf(fid,outstring);
end
fclose(fid);
