function result = computeBondDHAngle(M)
% result = computeBondDHAngle(M) computes the bond angle in DH form between consecutive
% vectors in rows of M.  This is the bond angle in radians - pi, so it is in [-pi,0].

u = M(1,:);
v = M(2,:);
u = u/norm(u);
v = v/norm(v);
result = acos(-u*(v'))-pi; % return angle
