function result = makeSideCoords(loop)
% given a list or matrix of backbone coordinates for N, CA, C,
% computes and returns the H, Cb, and O, hanging off them.
% atomTypeNo indexes into operFcnHdl = [@oper_n2h, @oper_ca2cb, @oper_c2o], 
% which do the computation. 

atomTypeNo = loop.atomTypeNo;
bbCoords = loop.coords;
solnCount = loop.solnCount;

operFcnHdl = {@oper_n2h, @oper_ca2cb, @oper_c2o};
sideCoords = zeros(length(atomTypeNo)-2,3,size(bbCoords,3),size(bbCoords,4));
for k = 1:size(bbCoords,3)
    for m = 1:solnCount(k)
        for i = 1:length(atomTypeNo)-2;
            sideCoords(i,:,k,m) = operFcnHdl{atomTypeNo(i+1)}(bbCoords(i,:,k,m), bbCoords(i+1,:,k,m),bbCoords(i+2,:, k,m)); 
        end
    end
end
result = sideCoords;
