function frame = makeFrame(coords)
%  frame = makeFrame(coords) makes a frame from 3 coordinates that are rows
%  in matrix coords.

z0 = coords(3,:)-coords(2,:); % z coordinate points along 2->3
z0 = z0/norm(z0);
prev = coords(1,:)-coords(2,:); % y is in the plane spanned by 1,2,3
prev = prev/norm(prev);
x0 = cross(prev,z0); x0 = x0/norm(x0); % x is normal to the plane
y0 = cross(z0,x0); y0 = y0/norm(y0);
frame = [x0', y0', z0', coords(2,:)'; 0 0 0 1]; 