function chain = offsetToPeptide(atomTypeNo, ppChain, cnPos)
% result = offsetToPeptide(atomTypeNo, ppChain, cnMult) takes the
% multipliers computed by peptideToOffset (q.v.) and restores the C and N 
% atom positions. 

chain = ppChain;
Cas = find(atomTypeNo(1:end-3) == 2); % list indices of all Calphas except last one.
for k = 1:size(chain,3)
    for i = 1:length(Cas) %iterate over all Calphas except last.
        Ca = Cas(i);
        j = 2*i - 1;
        C = (1 - cnPos(j  ,k))*chain(Ca  ,:,k) + cnPos(j  ,k)*chain(Ca+1,:,k);
        N = (1 - cnPos(j+1,k))*chain(Ca+3,:,k) + cnPos(j+1,k)*chain(Ca+2,:,k);
    end
end