function cbetaCoords = oper_ca2cb(pN, pCa, pC)

deg = pi/180;

%% Cbeta information
nCaCbAng = 110.4*deg;
cCaCbAng = 110.6*deg;
caCbLen = 1.521;

NsideDih = 123.0*deg;
CsideDih = 123.1*deg;

% The N - C - CA - CB dihedral should be 123.1, and the C - CA - CB angle should 
% be 110.4.
% The C - N - CA - CB dihedral should be -123.0, and the N - CA - CB angle 
% should be 110.6 (all in degrees).
% The CA - CB bond should be 1.536 A long.

ca2cbFrame = getOriginalFrame(pN,pCa,pC, nCaCbAng, cCaCbAng, NsideDih, CsideDih);
cbetaCoords = ca2cbFrame*[0 0 caCbLen 1]';
cbetaCoords = cbetaCoords(1:3)';
