function chain = peptideP1P2toCN(atomTypeNo, ppChain, cnPos)
% result = peptideP1P2toCN(atomTypeNo, ppChain, cnMult) takes the
% multipliers computed by peptideToOffset (q.v.) and restores the C and N 
% atom positions. 

chain = ppChain;
Cas = find(atomTypeNo(1:end-3) == 2); % list indices of all Calphas except last one.
for k = 1:size(chain,3)
    for i = 1:length(Cas) %iterate over all Calphas except last.
        Ca = Cas(i);
        chain(Ca+1,:,k) = (1 - cnPos(1,i,k))*chain(Ca  ,:,k) + cnPos(1,i,k)*chain(Ca+1,:,k); % fix C
        chain(Ca+2,:,k) = (1 - cnPos(2,i,k))*chain(Ca+3,:,k) + cnPos(2,i,k)*chain(Ca+2,:,k); % fix N
    end
end