function plotAtoms(loop, noclear)
% plot the original backbone and sidecoords for a loop. 
% draws all in yellow, then nearest to ideal in black and current in blue. 

if nargin > 1 && noclear
else
    clf; hold on; axis equal
end
n = size(loop.coords,1);
k = loop.original;
p = [loop.coords(:,:,k); loop.sidecoords(:,:,k)]; 
ind = [2:n-1; n+(1:n-2); 2:n-1];
ind = [1; ind(:); n];
p = p(ind,:,:,:); % re-arrange points to go out to side coord and back. 
plot3(p(:,1), p(:,2), p(:,3), 'b');

nInd = find(loop.atomTypeNo==1);
caInd = find(loop.atomTypeNo==2);
cInd = find(loop.atomTypeNo==3);
hInd = find(loop.atomTypeNo(2:end-1)==1);
rInd = find(loop.atomTypeNo(2:end-1)==2);
oInd = find(loop.atomTypeNo(2:end-1)==3);

for k = 1:size(loop.coords,3)
    for m = 1:loop.solnCount(k)
        plot3(loop.coords(nInd,1,k,m), loop.coords(nInd,2,k,m), loop.coords(nInd,3,k,m), 'bo'); 
        plot3(loop.coords(cInd,1,k,m), loop.coords(cInd,2,k,m), loop.coords(cInd,3,k,m), 'ko');
        plot3(loop.coords(caInd,1,k,m), loop.coords(caInd,2,k,m), loop.coords(caInd,3,k,m), 'ko');
        
        plot3(loop.sidecoords(hInd,1,k,m), loop.sidecoords(hInd,2,k,m), loop.sidecoords(hInd,3,k,m), 'yo');
        plot3(loop.sidecoords(rInd,1,k,m), loop.sidecoords(rInd,2,k,m), loop.sidecoords(rInd,3,k,m), 'go');
        plot3(loop.sidecoords(oInd,1,k,m), loop.sidecoords(oInd,2,k,m), loop.sidecoords(oInd,3,k,m), 'ro');
    end
end
