function plotLoop(loop, noclear)
% plot the backbones and sidecoords for a loop. 
% draws all in yellow, then nearest to ideal in black and current in blue. 

if nargin > 1 && noclear
else
    clf; hold on; axis equal
end
n = size(loop.coords,1);
kk = size(loop.coords,3);
p = [loop.coords; loop.sidecoords];
ind = [2:n-1; n+(1:n-2); 2:n-1];
ind = [1; ind(:); n];
p = p(ind,:,:,:); % re-arrange points to go out to side coord and back. 
for k = 1:kk
    for m = 1:loop.solnCount(k);
        plot3(p(:,1,k,m), p(:,2,k,m), p(:,3,k,m), 'y');
    end 
end
if kk > 1
    [v,k] = min(abs(loop.wigDelta-loop.wigIdeal));
    plot3(p(:,1,k), p(:,2,k), p(:,3,k), 'k');
    k = loop.original;
    plot3(p(:,1,k), p(:,2,k), p(:,3,k), 'b');
end
