function chain = recoverPPchain(ikParams, atomTypeNo, ppChain, startFrame)
% chain = recoverPPchain(ikParams, atomTypeNo, ppChain) reconstructs the
% ppChain from the ikParams

chain = ppChain; % copy for size and to get first and last points.

kk = size(chain,3);
for k = 1:kk % audit 
    sf = makeFrame(ppChain(1:3,:, k)); % either cb:C N Ca or 2cb:N Ca P1. Dihedral is a phi or psi. 
    if norm(startFrame-sf) >1e-9
        fprintf('startFrame does not match in recoverPPchain\n');
        startFrame-sf
    end
end

torad = pi/180;
for k = 1:kk
    count = 2; % we start with two good atoms in chain
    frame = startFrame;
    for i = 1:size(ikParams,1)
        count = count+1;
        p = ikParams(i,:,k);
        C = cos(p(1)*torad);
        S = sin(p(1)*torad);
        L = cos(p(2)*torad);
        M = sin(p(2)*torad);
        a = p(4);
        
        frame = frame*[C -S*L   S*M  a*C; % apply DH
            S  C*L  -C*M  a*S;
            0   M     L   p(3);
            0   0     0   1];
        % save point(s)
        if abs(a) > 1e-12 % For non-zero offsets, 
            chain(count,:,k) = (frame(1:3,4)- a*frame(1:3,1))'; % make P1 coordinate
            count = count+1; 
        end
        chain(count,:,k) = frame(1:3,4)'; % N or Calpha
    end
end

