% unused stuff

% Spherical angles by projections
% need projections: p1r s3r q1r s1q1 rq1 p3q3 rq3 p1q1 q3q1 p2q1
p1r=1; s3r=2; q1r=3; s1q1=4; rq1=5; p3q3=6; rq3=7; p1q1=8; q3q1=9; p2q1=10; s2q3=11; q1q3 = 12; q3r=13; s1q1=14;
P = V([p1 s3 q1 s1 r  p3 r  p1 q3 p2, s2 q1 q3 s1], :);
R = V([r  r  r  q1 q1 q3 q3 q1 q1 q1, q3 q3 r  q1], :);
pr = P - repmat(dot(P,R,2),1,3).*R; % vectors in plane PR orthog to R
norms = sqrt(sum(pr.^2,2));
assert(all(norms>1e-6), 'Small norm defining omega\n', pr);
pr = pr./repmat(norms,1,3);
sa2 = real(acos(dot(pr([s3r q1r q1r, s1q1 p3q3, p1q1 s1q1 q3q1, p2q1 s2q3, q1r s1q1 s2q3],:), ...
               pr([p1r p1r s3r, rq1  rq3,  rq1  p1q1 p2q1, rq1  q1q3, q3r p2q1 p3q3],:), 2)));

           
% check derivation of eqn (1) DD...
assert(abs(-cos(D1) + cos(G1)*cos(L1)+sin(G1)*sin(L1)*cos(sa(zeB))) < 1e-8, ' (A1)~= 0', ...
    [cos(D1), cos(G1)*cos(L1)+sin(G1)*sin(L1)*cos(sa(zeB)) cos(G1)*cos(L1) sin(G1)*sin(L1)*cos(sa(zeB)) cos(D1)  cos(G1) cos(L1) sin(G1) sin(L1) cos(sa(zeB))]);
assert(abs(-cos(L1) + cos(A1)*cos(B1)+sin(A1)*sin(B1)*cos(sa(om1))) < 1e-8, ' (A2)~= 0', ...
    [cos(L1)  cos(A1)*cos(B1)+sin(A1)*sin(B1)*cos(sa(om1)) cos(A1)*cos(B1) sin(A1)*sin(B1)*cos(sa(om1)) cos(L1)  cos(A1) cos(B1) sin(A1) sin(B1) cos(sa(om1))]);
assert(abs(-cos(sa(zeB)) + cos(sa(ze1))*cos(sa(zeA))+sin(sa(ze1))*sin(sa(zeA))) < 1e-8, ' (A3)~= 0', ...
    [cos(sa(zeB))  cos(sa(ze1))*cos(sa(zeA))+sin(sa(ze1))*sin(sa(zeA))]);
assert(abs(-sin(L1)*cos(sa(zeB)) + cos(sa(ze1))*sin(L1)*cos(sa(zeA))+sin(sa(ze1))*sin(L1)*sin(sa(zeA))) < 1e-8, ' (A4/5)~= 0', ...
    [sin(L1)*cos(sa(zeB))  cos(sa(ze1))*sin(L1)*cos(sa(zeA))+sin(sa(ze1))*sin(L1)*sin(sa(zeA))]);
assert(abs(-sin(L1)*sin(sa(zeA)) + sin(A1)*sin(sa(om1))) < 1e-8, ' (A6)~= 0', ...
    [sin(L1)*sin(sa(zeA))  sin(A1)*sin(sa(om1))]);
assert(abs(-cos(A1) + cos(B1)*cos(L1)+sin(B1)*sin(L1)*cos(sa(zeA))) < 1e-8, ' (A7)~= 0', ...
    [cos(A1)  cos(B1)*cos(L1)+sin(B1)*sin(L1)*cos(sa(zeA))]);
assert(abs(-sin(L1)*cos(sa(zeA)) + cos(A1)*sin(B1)-sin(A1)*cos(B1)*cos(sa(om1))) < 1e-8, ' (A10)~= 0', ...
    [sin(L1)*cos(sa(zeA))  cos(A1)*sin(B1)-sin(A1)*cos(B1)*cos(sa(om1))]);
assert(abs(-sin(L1)*cos(sa(zeB)) + cos(sa(ze1))*(cos(A1)*sin(B1)-sin(A1)*cos(B1)*cos(sa(om1)))+sin(sa(ze1))*sin(sa(om1))*sin(A1)) < 1e-8, ' (A11)~= 0', ...
    [sin(L1)*cos(sa(zeB))  cos(sa(ze1))*(cos(A1)*sin(B1)-sin(A1)*cos(B1)*cos(sa(om1)))+sin(sa(ze1))*sin(sa(om1))*sin(A1)]);
assert(abs([1 cos(sa(om1)) cos(sa(ze1)) cos(sa(om1))*cos(sa(ze1)) sin(sa(om1))*sin(sa(ze1))]*CC) < 1e-8, ' (A13)~= 0', ...
    [1 cos(sa(om1)) cos(sa(ze1)) cos(sa(om1))*cos(sa(ze1)) sin(sa(om1))*sin(sa(ze1))]*CC);



% compute Z3 from W1 (two different ways, and compare to z3)
k0 = conv(a2,b2)-conv(a4,b0);
k1 = conv(a3,b2)-conv(a4,b1);
k2 = conv(a1,b2b2)-conv(k1,b0);
k3 = conv(k0,b2)-conv(k1,b1);

Z3 = (polyval(k3,W1).*polyval(b0,W1)-polyval(a0,W1).*polyval(b2,W1).^3)...
   ./(polyval(k2,W1).*polyval(b2,W1)-polyval(k3,W1).*polyval(b1,W1));

%check that numerical polynomial value is zero, too
A0 = polyval(a0,W1); A1 = polyval(a1,W1); A2 = polyval(a2,W1); A3 = polyval(a3,W1); A4 = polyval(a4,W1);
B0 = polyval(b0,W1); B1 = polyval(b1,W1); B2 = polyval(b2,W1);
A0^2*B2^4 +A0*A4*B1^4 -2*A0*A2*B0*B2^3 -A0*A1*B1*B2^3 +A0*A2*B1^2*B2^2 +3*A0*A3*B0*B1*B2^2 +2*A0*A4*B0^2*B2^2 -A0*A3*B1^3*B2 -4*A0*A4*B0*B1^2*B2 +A1^2*B0*B2^3 -A1*A2*B0*B1*B2^2 -A1*A4*B0*B1^3 +A1*A3*B0*B1^2*B2 +3*A1*A4*B0^2*B1*B2 -2*A1*A3*B0^2*B2^2 +A2^2*B0^2*B2^2 +A2*A4*B0^2*B1^2 -A2*A3*B0^2*B1*B2 -2*A2*A4*B0^3*B2 -A3*A4*B0^3*B1 +A3^2*B0^3*B2 +A4^2*B0^4

% use omega to find position of ca2
    XX = X(om1,:)/norm(X(om1,:)); YY = Y(om1,:)/norm(Y(om1,:)); ZZ = V(r,:); % coord system for q1
    assert(abs(dot(v(q1,:),YY))<1e-9,'q1 not orthog to YY ', i);
    Q1 = dot(v(q1,:),XX)*(cos(domega(i))*XX - sin(domega(i))*YY) + dot(v(q1,:),ZZ)*ZZ; % make new vector Q1
    result(ca2,:,i) = chain(ca1,:) + Q1; % position Calpha2
    
    
    
% Rotate first peptide plane around Q1: zeta1 is angle from rQ1 to Q1S1
    pp = chain([c1 n2],:)-chain([ca1 ca1],:); % vectors to c1 & n2 atoms in peptide 
    pplen2 = dot(pp,pp,2); % lengths
    ppproj = dot(pp,V([q1 q1],:),2); % projection of peptide vectors onto unit(q1)
    ppproj2 = dot(ppproj,ppproj,2);
    pplen = [1; -1].*sqrt(pplen2 - ppproj2); % Lengths of projections on XY. Assumes opposite sides of Q1.
    
    nQ = Q1/norm(Q1); 
    YY = -cross(V(r,:), nQ); nY = YY/norm(YY);
    XX = cross(YY, nQ); nX = XX/norm(XX); % coord system is nX, nY, nQ
    
    result(c1,:,i) = chain(ca1,:) + pplen(1)*(cos(zeta1(i))*nX-sin(zeta1(i))*nY) + sqrt(ppproj2(1))*nQ;
    result(n2,:,i) = chain(ca1,:) + pplen(2)*(cos(zeta1(i))*nX-sin(zeta1(i))*nY) + sqrt(ppproj2(2))*nQ;
   
    pp = chain([c2 n3],:)-chain([ca3 ca3],:); % vectors to c2 & n3 atoms in peptide 
    pplen2 = dot(pp,pp,2); % lengths
    ppproj = dot(pp,V([q3 q3],:),2); % projection of peptide vectors onto unit(q3)
    ppproj2 = dot(ppproj,ppproj,2);
    pplen = [1; -1].*sqrt(pplen2 - ppproj2); % Lengths of projections on XY. Assumes opposite sides of Q1.
    
    nQ = Q3/norm(Q3); 
    YY = cross(V(r,:), nQ); nY = YY/norm(YY);
    XX = cross(YY, nQ); nX = XX/norm(XX); % coord system is nX, nY, nQ
    
    result(c2,:,i) = chain(ca3,:) + pplen(1)*(cos(zeta1(i))*nX-sin(zeta1(i))*nY) + sqrt(ppproj2(1))*nQ;
    result(n3,:,i) = chain(ca3,:) + pplen(2)*(cos(zeta1(i))*nX-sin(zeta1(i))*nY) + sqrt(ppproj2(2))*nQ;

    % We undo the rotation of original peptide planes to prepare to build output coords
pS1 = rotby(v(s1,:), V(q1,:), -sa(ze1)); 
pB1 = rotby(v(pb1,:), V(q1,:), -sa(ze1)); 
pB3 = rotby(v(pb3,:), V(q3,:), -sa(ze3)); 
pP3 = rotby(v(p3,:), V(q3,:), -sa(ze3)); 
assert(abs(dot(pS1,cross(V(r,:), V(q1,:)))) < 1e-9, ' failed to rotate peptide pS1 to q1r plane');
assert(abs(dot(pB1,cross(-V(r,:), V(q1,:)))) < 1e-9, ' failed to rotate peptide pB1 to q1r plane');
assert(abs(dot(pB3,cross(-V(r,:), V(q3,:)))) < 1e-9, ' failed to rotate peptide pB3 to q3r plane');
assert(abs(dot(pP3,cross(V(r,:), V(q3,:)))) < 1e-9, ' failed to rotate peptide pP3 to q3r plane');

    
    % Rotate peptide plane around Q1: zeta1 is angle from S1Q1 to rQ1
    result(c1,:,i) = chain(ca1,:) + rotby(rotby(pS1, V(r,:), -domega(i)), Q1, zeta1(i));
    result(n2,:,i) = chain(ca1,:) + rotby(rotby(pB1, V(r,:), -domega(i)), Q1, zeta1(i));
    result(c2,:,i) = chain(ca3,:) + rotby(rotby(pB3, V(r,:), -domega(i)), Q3, zeta3(i));
    result(n3,:,i) = chain(ca3,:) + rotby(rotby(pP3, V(r,:), -domega(i)), Q3, zeta3(i));
